
;CodeVisionAVR C Compiler V1.25.9 Professional
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega16
;Program type           : Application
;Clock frequency        : 12,000000 MHz
;Memory model           : Small
;Optimize for           : Speed
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 512 byte(s)
;Heap size              : 128 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega16
	#pragma AVRPART MEMORY PROG_FLASH 16384
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "hw3.vec"
	.INCLUDE "hw3.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x380)
	LDI  R25,HIGH(0x380)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x3DF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x3DF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x260)
	LDI  R29,HIGH(0x260)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x260
;       1 /*****************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.25.9 Professional
;       4 Automatic Program Generator
;       5  Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;       6 http://www.hpinfotech.com
;       7 
;       8 Project :
;       9 Version :
;      10 Date    : 09.06.2008
;      11 Author  : F4CG
;      12 Company : F4CG
;      13 Comments:
;      14 
;      15 
;      16 Chip type           : ATmega16
;      17 Program type        : Application
;      18 Clock frequency     : 12,000000 MHz
;      19 Memory model        : Small
;      20 External SRAM size  : 0
;      21 Data Stack size     : 256
;      22 *****************************************************/
;      23 
;      24 #include <mega16.h>
;      25 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;      26 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;      27 	.EQU __se_bit=0x40
	.EQU __se_bit=0x40
;      28 	.EQU __sm_mask=0xB0
	.EQU __sm_mask=0xB0
;      29 	.EQU __sm_powerdown=0x20
	.EQU __sm_powerdown=0x20
;      30 	.EQU __sm_powersave=0x30
	.EQU __sm_powersave=0x30
;      31 	.EQU __sm_standby=0xA0
	.EQU __sm_standby=0xA0
;      32 	.EQU __sm_ext_standby=0xB0
	.EQU __sm_ext_standby=0xB0
;      33 	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_adc_noise_red=0x10
;      34 	.SET power_ctrl_reg=mcucr
	.SET power_ctrl_reg=mcucr
;      35 	#endif
	#endif
;      36 #include <delay.h>
;      37 #include <math.h>
;      38 
;      39 
;      40 // Alphanumeric LCD Module functions
;      41 #asm
;      42    .equ __lcd_port=0x1B ;PORTA
   .equ __lcd_port=0x1B ;PORTA
;      43 #endasm
;      44 #include <lcd.h>
;      45 
;      46 #define light_on PORTC.0=1;
;      47 #define light_off PORTC.0=0;
;      48 
;      49 const double P2=2*PI;

	.CSEG
;      50 const double DR=PI/180;
;      51 const double K1=0.262516168343;
;      52 
;      53 const unsigned days_month[12]={31,28,31,30,31,30,31,31,30,31,30,31};
;      54 
;      55 long int hr, mins, sec, msec, Y=2009, cc = 0, M=1, day=12, C0, H=3, B5=69;

	.DSEG
_hr:
	.BYTE 0x4
_mins:
	.BYTE 0x4
_sec:
	.BYTE 0x4
_msec:
	.BYTE 0x4
_Y:
	.BYTE 0x4
_cc:
	.BYTE 0x4
_M:
	.BYTE 0x4
_day:
	.BYTE 0x4
_C0:
	.BYTE 0x4
_H:
	.BYTE 0x4
_B5:
	.BYTE 0x4
;      56 long int J3, H3, M3;
_J3:
	.BYTE 0x4
_H3:
	.BYTE 0x4
_M3:
	.BYTE 0x4
;      57 
;      58 unsigned int MM[2], HH[2];
_MM:
	.BYTE 0x4
_HH:
	.BYTE 0x4
;      59 double aA[2], aD[2];
_aA:
	.BYTE 0x8
_aD:
	.BYTE 0x8
;      60 
;      61 double L5=33.15, Z, Z0, Z1, D, A5, D5, R5, T, T0, TT, T3, L0, L2, H0, H1, H2,
_L5:
	.BYTE 0x4
_Z:
	.BYTE 0x4
_Z0:
	.BYTE 0x4
_Z1:
	.BYTE 0x4
_D:
	.BYTE 0x4
_A5:
	.BYTE 0x4
_D5:
	.BYTE 0x4
_R5:
	.BYTE 0x4
_T:
	.BYTE 0x4
_T0:
	.BYTE 0x4
_TT:
	.BYTE 0x4
_T3:
	.BYTE 0x4
_L0:
	.BYTE 0x4
_L2:
	.BYTE 0x4
_H0:
	.BYTE 0x4
_H1:
	.BYTE 0x4
_H2:
	.BYTE 0x4
;      62        M8, W8, A, B, A0, D0, A2, D1, D2, DA, DD, E, F, J, S, C, P, L, G, V, U, W, V0, V1, V2;
_M8:
	.BYTE 0x4
_W8:
	.BYTE 0x4
_A:
	.BYTE 0x4
_B:
	.BYTE 0x4
_A0:
	.BYTE 0x4
_D0:
	.BYTE 0x4
_A2:
	.BYTE 0x4
_D1:
	.BYTE 0x4
_D2:
	.BYTE 0x4
_DA:
	.BYTE 0x4
_DD:
	.BYTE 0x4
_E:
	.BYTE 0x4
_F:
	.BYTE 0x4
_J:
	.BYTE 0x4
_S:
	.BYTE 0x4
_C:
	.BYTE 0x4
_P:
	.BYTE 0x4
_L:
	.BYTE 0x4
_G:
	.BYTE 0x4
_V:
	.BYTE 0x4
_U:
	.BYTE 0x4
_W:
	.BYTE 0x4
_V0:
	.BYTE 0x4
_V1:
	.BYTE 0x4
_V2:
	.BYTE 0x4
;      63 
;      64 char delim=':';
;      65 
;      66 bit st;
;      67 
;      68 
;      69 // Timer 0 overflow interrupt service routine
;      70 interrupt [TIM0_OVF] void timer0_ovf_isr(void)
;      71 {

	.CSEG
_timer0_ovf_isr:
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;      72   cc++;
	LDS  R30,_cc
	LDS  R31,_cc+1
	LDS  R22,_cc+2
	LDS  R23,_cc+3
	__SUBD1N -1
	STS  _cc,R30
	STS  _cc+1,R31
	STS  _cc+2,R22
	STS  _cc+3,R23
;      73   if (cc>=1) {msec++; cc=0;};
	LDS  R26,_cc
	LDS  R27,_cc+1
	LDS  R24,_cc+2
	LDS  R25,_cc+3
	__CPD2N 0x1
	BRLT _0xA
	LDS  R30,_msec
	LDS  R31,_msec+1
	LDS  R22,_msec+2
	LDS  R23,_msec+3
	__SUBD1N -1
	STS  _msec,R30
	STS  _msec+1,R31
	STS  _msec+2,R22
	STS  _msec+3,R23
	LDI  R30,0
	STS  _cc,R30
	STS  _cc+1,R30
	STS  _cc+2,R30
	STS  _cc+3,R30
_0xA:
;      74     // Place your code here
;      75 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	RETI
;      76 
;      77 
;      78 
;      79 // Declare your global variables here
;      80 
;      81 
;      82 
;      83 
;      84 void sun_info()
;      85 { int i;
_sun_info:
;      86   for (i=0; i<2; i++)
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16,R17
	__GETWRN 16,17,0
_0xC:
	__CPWRN 16,17,2
	BRLT PC+3
	JMP _0xD
;      87   {
;      88     lcd_gotoxy(9*i,0);
	MOVW R30,R16
	LDI  R26,LOW(9)
	LDI  R27,HIGH(9)
	CALL __MULW12
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _lcd_gotoxy
;      89     lcd_putchar (HH[i]/10%10+0x30);
	MOVW R30,R16
	LDI  R26,LOW(_HH)
	LDI  R27,HIGH(_HH)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21U
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21U
	ADIW R30,48
	ST   -Y,R30
	CALL _lcd_putchar
;      90     lcd_putchar (HH[i]%10+0x30);
	MOVW R30,R16
	LDI  R26,LOW(_HH)
	LDI  R27,HIGH(_HH)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21U
	ADIW R30,48
	ST   -Y,R30
	CALL _lcd_putchar
;      91     lcd_putchar (':');
	LDI  R30,LOW(58)
	ST   -Y,R30
	CALL _lcd_putchar
;      92     lcd_putchar (MM[i]/10%10+0x30);
	MOVW R30,R16
	LDI  R26,LOW(_MM)
	LDI  R27,HIGH(_MM)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21U
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21U
	ADIW R30,48
	ST   -Y,R30
	CALL _lcd_putchar
;      93     lcd_putchar (MM[i]%10+0x30);
	MOVW R30,R16
	LDI  R26,LOW(_MM)
	LDI  R27,HIGH(_MM)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21U
	ADIW R30,48
	ST   -Y,R30
	CALL _lcd_putchar
;      94   }
	__ADDWRN 16,17,1
	RJMP _0xC
_0xD:
;      95 }
	LD   R16,Y+
	LD   R17,Y+
	RET
;      96 
;      97 long int Trunc (double x)
;      98 {
_Trunc:
;      99   double y, n;
;     100   y = modf(x, &n);
	SBIW R28,8
;	x -> Y+8
;	y -> Y+4
;	n -> Y+0
	__GETD1S 8
	CALL __PUTPARD1
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	CALL _modf
	__PUTD1S 4
;     101   return (int)n;
	__GETD1S 0
	CALL __CFD1
	CALL __CWD1
	ADIW R28,12
	RET
;     102 }
;     103 
;     104 int Sgn(float x)
;     105 {
_Sgn:
;     106   return( x>=0 ?1:-1);
;	x -> Y+0
	__GETD2S 0
	CALL __CPD20
	BRLT _0xE
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0xF
_0xE:
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
_0xF:
	ADIW R28,4
	RET
;     107 }
;     108 
;     109 void Calendar(void)
;     110 {
_Calendar:
;     111   G = 1;
	__GETD1N 0x3F800000
	STS  _G,R30
	STS  _G+1,R31
	STS  _G+2,R22
	STS  _G+3,R23
;     112   if (Y < 1583) {G = 0;};
	LDS  R26,_Y
	LDS  R27,_Y+1
	LDS  R24,_Y+2
	LDS  R25,_Y+3
	__CPD2N 0x62F
	BRGE _0x11
	__GETD1N 0x0
	STS  _G,R30
	STS  _G+1,R31
	STS  _G+2,R22
	STS  _G+3,R23
_0x11:
;     113   D1 = Trunc(D);
	LDS  R30,_D
	LDS  R31,_D+1
	LDS  R22,_D+2
	LDS  R23,_D+3
	CALL __PUTPARD1
	CALL _Trunc
	CALL __CDF1
	STS  _D1,R30
	STS  _D1+1,R31
	STS  _D1+2,R22
	STS  _D1+3,R23
;     114   F = D - D1 - 0.5;
	LDS  R26,_D1
	LDS  R27,_D1+1
	LDS  R24,_D1+2
	LDS  R25,_D1+3
	LDS  R30,_D
	LDS  R31,_D+1
	LDS  R22,_D+2
	LDS  R23,_D+3
	CALL __SUBF12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x3F000000
	CALL __SWAPD12
	CALL __SUBF12
	STS  _F,R30
	STS  _F+1,R31
	STS  _F+2,R22
	STS  _F+3,R23
;     115   J = -Trunc(7 * (Trunc((M + 9) / 12) + Y) / 4);
	LDS  R30,_M
	LDS  R31,_M+1
	LDS  R22,_M+2
	LDS  R23,_M+3
	__ADDD1N 9
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xC
	CALL __DIVD21
	CALL __CDF1
	CALL __PUTPARD1
	CALL _Trunc
	LDS  R26,_Y
	LDS  R27,_Y+1
	LDS  R24,_Y+2
	LDS  R25,_Y+3
	CALL __ADDD12
	__GETD2N 0x7
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x4
	CALL __DIVD21
	CALL __CDF1
	CALL __PUTPARD1
	CALL _Trunc
	CALL __ANEGD1
	CALL __CDF1
	STS  _J,R30
	STS  _J+1,R31
	STS  _J+2,R22
	STS  _J+3,R23
;     116   if (G == 1)
	LDS  R26,_G
	LDS  R27,_G+1
	LDS  R24,_G+2
	LDS  R25,_G+3
	__CPD2N 0x3F800000
	BREQ PC+3
	JMP _0x12
;     117   {
;     118     S = Sgn(M - 9);
	LDS  R30,_M
	LDS  R31,_M+1
	LDS  R22,_M+2
	LDS  R23,_M+3
	__SUBD1N 9
	CALL __CDF1
	CALL __PUTPARD1
	CALL _Sgn
	CALL __CWD1
	CALL __CDF1
	STS  _S,R30
	STS  _S+1,R31
	STS  _S+2,R22
	STS  _S+3,R23
;     119     A = abs(M - 9);
	LDS  R30,_M
	LDS  R31,_M+1
	LDS  R22,_M+2
	LDS  R23,_M+3
	__SUBD1N 9
	ST   -Y,R31
	ST   -Y,R30
	CALL _abs
	CLR  R22
	CLR  R23
	CALL __CDF1
	STS  _A,R30
	STS  _A+1,R31
	STS  _A+2,R22
	STS  _A+3,R23
;     120     J3 = Trunc(Y + S * Trunc(A / 7));
	LDS  R26,_A
	LDS  R27,_A+1
	LDS  R24,_A+2
	LDS  R25,_A+3
	__GETD1N 0x40E00000
	CALL __DIVF21
	CALL __PUTPARD1
	CALL _Trunc
	LDS  R26,_S
	LDS  R27,_S+1
	LDS  R24,_S+2
	LDS  R25,_S+3
	CALL __CDF1
	CALL __MULF12
	LDS  R26,_Y
	LDS  R27,_Y+1
	LDS  R24,_Y+2
	LDS  R25,_Y+3
	CALL __CDF2
	CALL __ADDF12
	CALL __PUTPARD1
	CALL _Trunc
	STS  _J3,R30
	STS  _J3+1,R31
	STS  _J3+2,R22
	STS  _J3+3,R23
;     121     J3 = -(((J3 / 100) + 1) * 3 / 4);
	LDS  R26,_J3
	LDS  R27,_J3+1
	LDS  R24,_J3+2
	LDS  R25,_J3+3
	__GETD1N 0x64
	CALL __DIVD21
	__ADDD1N 1
	__GETD2N 0x3
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x4
	CALL __DIVD21
	CALL __ANEGD1
	STS  _J3,R30
	STS  _J3+1,R31
	STS  _J3+2,R22
	STS  _J3+3,R23
;     122   }
;     123   J = J + Trunc(275 * M / 9) + D1 + G * J3;
_0x12:
	LDS  R30,_M
	LDS  R31,_M+1
	LDS  R22,_M+2
	LDS  R23,_M+3
	__GETD2N 0x113
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x9
	CALL __DIVD21
	CALL __CDF1
	CALL __PUTPARD1
	CALL _Trunc
	LDS  R26,_J
	LDS  R27,_J+1
	LDS  R24,_J+2
	LDS  R25,_J+3
	CALL __CDF1
	CALL __ADDF12
	LDS  R26,_D1
	LDS  R27,_D1+1
	LDS  R24,_D1+2
	LDS  R25,_D1+3
	CALL __ADDF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_J3
	LDS  R31,_J3+1
	LDS  R22,_J3+2
	LDS  R23,_J3+3
	LDS  R26,_G
	LDS  R27,_G+1
	LDS  R24,_G+2
	LDS  R25,_G+3
	CALL __CDF1
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDF12
	STS  _J,R30
	STS  _J+1,R31
	STS  _J+2,R22
	STS  _J+3,R23
;     124   J = J + 1721027 + 2 * G + 367 * Y;
	__GETD2N 0x49D21618
	CALL __ADDF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_G
	LDS  R31,_G+1
	LDS  R22,_G+2
	LDS  R23,_G+3
	__GETD2N 0x40000000
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_Y
	LDS  R31,_Y+1
	LDS  R22,_Y+2
	LDS  R23,_Y+3
	__GETD2N 0x16F
	CALL __MULD12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __CDF1
	CALL __ADDF12
	STS  _J,R30
	STS  _J+1,R31
	STS  _J+2,R22
	STS  _J+3,R23
;     125   if (F >= 0) {goto end;};
	LDS  R26,_F
	LDS  R27,_F+1
	LDS  R24,_F+2
	LDS  R25,_F+3
	CALL __CPD20
	BRGE _0x14
;     126   F = F + 1;
	LDS  R30,_F
	LDS  R31,_F+1
	LDS  R22,_F+2
	LDS  R23,_F+3
	__GETD2N 0x3F800000
	CALL __ADDF12
	STS  _F,R30
	STS  _F+1,R31
	STS  _F+2,R22
	STS  _F+3,R23
;     127   J = J - 1;
	LDS  R26,_J
	LDS  R27,_J+1
	LDS  R24,_J+2
	LDS  R25,_J+3
	__GETD1N 0x3F800000
	CALL __SWAPD12
	CALL __SUBF12
	STS  _J,R30
	STS  _J+1,R31
	STS  _J+2,R22
	STS  _J+3,R23
;     128 end:
_0x14:
;     129 }
	RET
;     130 
;     131 void GetTimeZone(void)
;     132 {
_GetTimeZone:
;     133   T0 = T / 36525;
	LDS  R26,_T
	LDS  R27,_T+1
	LDS  R24,_T+2
	LDS  R25,_T+3
	__GETD1N 0x470EAD00
	CALL __DIVF21
	STS  _T0,R30
	STS  _T0+1,R31
	STS  _T0+2,R22
	STS  _T0+3,R23
;     134   S = 24110.5 + 8640184.813 * T0;
	__GETD2N 0x4B03D6B9
	CALL __MULF12
	__GETD2N 0x46BC5D00
	CALL __ADDF12
	STS  _S,R30
	STS  _S+1,R31
	STS  _S+2,R22
	STS  _S+3,R23
;     135   S = S + 86636.6 * Z0 + 86400 * L5;
	LDS  R30,_Z0
	LDS  R31,_Z0+1
	LDS  R22,_Z0+2
	LDS  R23,_Z0+3
	__GETD2N 0x47A9364D
	CALL __MULF12
	LDS  R26,_S
	LDS  R27,_S+1
	LDS  R24,_S+2
	LDS  R25,_S+3
	CALL __ADDF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_L5
	LDS  R31,_L5+1
	LDS  R22,_L5+2
	LDS  R23,_L5+3
	__GETD2N 0x47A8C000
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDF12
	STS  _S,R30
	STS  _S+1,R31
	STS  _S+2,R22
	STS  _S+3,R23
;     136   S = S / 86400;
	LDS  R26,_S
	LDS  R27,_S+1
	LDS  R24,_S+2
	LDS  R25,_S+3
	__GETD1N 0x47A8C000
	CALL __DIVF21
	STS  _S,R30
	STS  _S+1,R31
	STS  _S+2,R22
	STS  _S+3,R23
;     137   S = S - Trunc(S);
	CALL __PUTPARD1
	CALL _Trunc
	LDS  R26,_S
	LDS  R27,_S+1
	LDS  R24,_S+2
	LDS  R25,_S+3
	CALL __CDF1
	CALL __SWAPD12
	CALL __SUBF12
	STS  _S,R30
	STS  _S+1,R31
	STS  _S+2,R22
	STS  _S+3,R23
;     138   T0 = S * 360 * DR;
	LDS  R26,_S
	LDS  R27,_S+1
	LDS  R24,_S+2
	LDS  R25,_S+3
	__GETD1N 0x43B40000
	CALL __MULF12
	MOVW R26,R30
	MOVW R24,R22
	LDI  R30,LOW(_DR*2)
	LDI  R31,HIGH(_DR*2)
	CALL __GETD1PF
	CALL __MULF12
	STS  _T0,R30
	STS  _T0+1,R31
	STS  _T0+2,R22
	STS  _T0+3,R23
;     139 }
	RET
;     140 
;     141 void PosOfSun(void)
;     142 {
_PosOfSun:
;     143 
;     144   //       
;     145   //  (Van Flandern & Pulkkinen, 1979)
;     146   L = 0.779072 + 0.00273790931 * T;
	LDS  R30,_T
	LDS  R31,_T+1
	LDS  R22,_T+2
	LDS  R23,_T+3
	__GETD2N 0x3B336E7F
	CALL __MULF12
	__GETD2N 0x3F477143
	CALL __ADDF12
	STS  _L,R30
	STS  _L+1,R31
	STS  _L+2,R22
	STS  _L+3,R23
;     147   G = 0.993126 + 0.0027377785 * T;
	LDS  R30,_T
	LDS  R31,_T+1
	LDS  R22,_T+2
	LDS  R23,_T+3
	__GETD2N 0x3B336C4D
	CALL __MULF12
	__GETD2N 0x3F7E3D81
	CALL __ADDF12
	STS  _G,R30
	STS  _G+1,R31
	STS  _G+2,R22
	STS  _G+3,R23
;     148   L = L - Trunc(L);
	LDS  R30,_L
	LDS  R31,_L+1
	LDS  R22,_L+2
	LDS  R23,_L+3
	CALL __PUTPARD1
	CALL _Trunc
	LDS  R26,_L
	LDS  R27,_L+1
	LDS  R24,_L+2
	LDS  R25,_L+3
	CALL __CDF1
	CALL __SWAPD12
	CALL __SUBF12
	STS  _L,R30
	STS  _L+1,R31
	STS  _L+2,R22
	STS  _L+3,R23
;     149   G = G - Trunc(G);
	LDS  R30,_G
	LDS  R31,_G+1
	LDS  R22,_G+2
	LDS  R23,_G+3
	CALL __PUTPARD1
	CALL _Trunc
	LDS  R26,_G
	LDS  R27,_G+1
	LDS  R24,_G+2
	LDS  R25,_G+3
	CALL __CDF1
	CALL __SWAPD12
	CALL __SUBF12
	STS  _G,R30
	STS  _G+1,R31
	STS  _G+2,R22
	STS  _G+3,R23
;     150   L = L * P2;
	LDI  R30,LOW(_P2*2)
	LDI  R31,HIGH(_P2*2)
	CALL __GETD1PF
	LDS  R26,_L
	LDS  R27,_L+1
	LDS  R24,_L+2
	LDS  R25,_L+3
	CALL __MULF12
	STS  _L,R30
	STS  _L+1,R31
	STS  _L+2,R22
	STS  _L+3,R23
;     151   G = G * P2;
	LDI  R30,LOW(_P2*2)
	LDI  R31,HIGH(_P2*2)
	CALL __GETD1PF
	LDS  R26,_G
	LDS  R27,_G+1
	LDS  R24,_G+2
	LDS  R25,_G+3
	CALL __MULF12
	STS  _G,R30
	STS  _G+1,R31
	STS  _G+2,R22
	STS  _G+3,R23
;     152   V = 0.39785 * sin(L);
	LDS  R30,_L
	LDS  R31,_L+1
	LDS  R22,_L+2
	LDS  R23,_L+3
	CALL __PUTPARD1
	CALL _sin
	__GETD2N 0x3ECBB2FF
	CALL __MULF12
	STS  _V,R30
	STS  _V+1,R31
	STS  _V+2,R22
	STS  _V+3,R23
;     153   V = V - 0.01000 * sin(L - G);
	LDS  R26,_G
	LDS  R27,_G+1
	LDS  R24,_G+2
	LDS  R25,_G+3
	LDS  R30,_L
	LDS  R31,_L+1
	LDS  R22,_L+2
	LDS  R23,_L+3
	CALL __SUBF12
	CALL __PUTPARD1
	CALL _sin
	__GETD2N 0x3C23D70A
	CALL __MULF12
	LDS  R26,_V
	LDS  R27,_V+1
	LDS  R24,_V+2
	LDS  R25,_V+3
	CALL __SWAPD12
	CALL __SUBF12
	STS  _V,R30
	STS  _V+1,R31
	STS  _V+2,R22
	STS  _V+3,R23
;     154   V = V + 0.00333 * sin(L + G);
	LDS  R30,_G
	LDS  R31,_G+1
	LDS  R22,_G+2
	LDS  R23,_G+3
	LDS  R26,_L
	LDS  R27,_L+1
	LDS  R24,_L+2
	LDS  R25,_L+3
	CALL __ADDF12
	CALL __PUTPARD1
	CALL _sin
	__GETD2N 0x3B5A3C21
	CALL __MULF12
	LDS  R26,_V
	LDS  R27,_V+1
	LDS  R24,_V+2
	LDS  R25,_V+3
	CALL __ADDF12
	STS  _V,R30
	STS  _V+1,R31
	STS  _V+2,R22
	STS  _V+3,R23
;     155   V = V - 0.00021 * TT * sin(L);
	LDS  R30,_TT
	LDS  R31,_TT+1
	LDS  R22,_TT+2
	LDS  R23,_TT+3
	__GETD2N 0x395C3372
	CALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_L
	LDS  R31,_L+1
	LDS  R22,_L+2
	LDS  R23,_L+3
	CALL __PUTPARD1
	CALL _sin
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __MULF12
	LDS  R26,_V
	LDS  R27,_V+1
	LDS  R24,_V+2
	LDS  R25,_V+3
	CALL __SWAPD12
	CALL __SUBF12
	STS  _V,R30
	STS  _V+1,R31
	STS  _V+2,R22
	STS  _V+3,R23
;     156   U = 1 - 0.03349 * cos(G);
	LDS  R30,_G
	LDS  R31,_G+1
	LDS  R22,_G+2
	LDS  R23,_G+3
	CALL __PUTPARD1
	CALL _cos
	__GETD2N 0x3D092CCF
	CALL __MULF12
	__GETD2N 0x3F800000
	CALL __SWAPD12
	CALL __SUBF12
	STS  _U,R30
	STS  _U+1,R31
	STS  _U+2,R22
	STS  _U+3,R23
;     157   U = U - 0.00014 * cos(2 * L);
	LDS  R30,_L
	LDS  R31,_L+1
	LDS  R22,_L+2
	LDS  R23,_L+3
	__GETD2N 0x40000000
	CALL __MULF12
	CALL __PUTPARD1
	CALL _cos
	__GETD2N 0x3912CCF7
	CALL __MULF12
	LDS  R26,_U
	LDS  R27,_U+1
	LDS  R24,_U+2
	LDS  R25,_U+3
	CALL __SWAPD12
	CALL __SUBF12
	STS  _U,R30
	STS  _U+1,R31
	STS  _U+2,R22
	STS  _U+3,R23
;     158   U = U + 0.00008 * cos(L);
	LDS  R30,_L
	LDS  R31,_L+1
	LDS  R22,_L+2
	LDS  R23,_L+3
	CALL __PUTPARD1
	CALL _cos
	__GETD2N 0x38A7C5AC
	CALL __MULF12
	LDS  R26,_U
	LDS  R27,_U+1
	LDS  R24,_U+2
	LDS  R25,_U+3
	CALL __ADDF12
	STS  _U,R30
	STS  _U+1,R31
	STS  _U+2,R22
	STS  _U+3,R23
;     159   W = -0.00010 - 0.04129 * sin(2 * L);
	LDS  R30,_L
	LDS  R31,_L+1
	LDS  R22,_L+2
	LDS  R23,_L+3
	__GETD2N 0x40000000
	CALL __MULF12
	CALL __PUTPARD1
	CALL _sin
	__GETD2N 0x3D291FB4
	CALL __MULF12
	__GETD2N 0xB8D1B717
	CALL __SWAPD12
	CALL __SUBF12
	STS  _W,R30
	STS  _W+1,R31
	STS  _W+2,R22
	STS  _W+3,R23
;     160   W = W + 0.03211 * sin(G);
	LDS  R30,_G
	LDS  R31,_G+1
	LDS  R22,_G+2
	LDS  R23,_G+3
	CALL __PUTPARD1
	CALL _sin
	__GETD2N 0x3D0385C6
	CALL __MULF12
	LDS  R26,_W
	LDS  R27,_W+1
	LDS  R24,_W+2
	LDS  R25,_W+3
	CALL __ADDF12
	STS  _W,R30
	STS  _W+1,R31
	STS  _W+2,R22
	STS  _W+3,R23
;     161   W = W + 0.00104 * sin(2 * L - G);
	LDS  R30,_L
	LDS  R31,_L+1
	LDS  R22,_L+2
	LDS  R23,_L+3
	__GETD2N 0x40000000
	CALL __MULF12
	LDS  R26,_G
	LDS  R27,_G+1
	LDS  R24,_G+2
	LDS  R25,_G+3
	CALL __SUBF12
	CALL __PUTPARD1
	CALL _sin
	__GETD2N 0x3A88509C
	CALL __MULF12
	LDS  R26,_W
	LDS  R27,_W+1
	LDS  R24,_W+2
	LDS  R25,_W+3
	CALL __ADDF12
	STS  _W,R30
	STS  _W+1,R31
	STS  _W+2,R22
	STS  _W+3,R23
;     162   W = W - 0.00035 * sin(2 * L + G);
	LDS  R30,_L
	LDS  R31,_L+1
	LDS  R22,_L+2
	LDS  R23,_L+3
	__GETD2N 0x40000000
	CALL __MULF12
	LDS  R26,_G
	LDS  R27,_G+1
	LDS  R24,_G+2
	LDS  R25,_G+3
	CALL __ADDF12
	CALL __PUTPARD1
	CALL _sin
	__GETD2N 0x39B78034
	CALL __MULF12
	LDS  R26,_W
	LDS  R27,_W+1
	LDS  R24,_W+2
	LDS  R25,_W+3
	CALL __SWAPD12
	CALL __SUBF12
	STS  _W,R30
	STS  _W+1,R31
	STS  _W+2,R22
	STS  _W+3,R23
;     163   W = W - 0.00008 * TT * sin(G);
	LDS  R30,_TT
	LDS  R31,_TT+1
	LDS  R22,_TT+2
	LDS  R23,_TT+3
	__GETD2N 0x38A7C5AC
	CALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_G
	LDS  R31,_G+1
	LDS  R22,_G+2
	LDS  R23,_G+3
	CALL __PUTPARD1
	CALL _sin
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __MULF12
	LDS  R26,_W
	LDS  R27,_W+1
	LDS  R24,_W+2
	LDS  R25,_W+3
	CALL __SWAPD12
	CALL __SUBF12
	STS  _W,R30
	STS  _W+1,R31
	STS  _W+2,R22
	STS  _W+3,R23
;     164   S = W / sqrt(U - V * V);
	LDS  R30,_V
	LDS  R31,_V+1
	LDS  R22,_V+2
	LDS  R23,_V+3
	LDS  R26,_V
	LDS  R27,_V+1
	LDS  R24,_V+2
	LDS  R25,_V+3
	CALL __MULF12
	LDS  R26,_U
	LDS  R27,_U+1
	LDS  R24,_U+2
	LDS  R25,_U+3
	CALL __SWAPD12
	CALL __SUBF12
	CALL __PUTPARD1
	CALL _sqrt
	LDS  R26,_W
	LDS  R27,_W+1
	LDS  R24,_W+2
	LDS  R25,_W+3
	CALL __DIVF21
	STS  _S,R30
	STS  _S+1,R31
	STS  _S+2,R22
	STS  _S+3,R23
;     165   A5 = L + atan(S / sqrt(1 - S * S));
	LDS  R26,_S
	LDS  R27,_S+1
	LDS  R24,_S+2
	LDS  R25,_S+3
	CALL __MULF12
	__GETD2N 0x3F800000
	CALL __SWAPD12
	CALL __SUBF12
	CALL __PUTPARD1
	CALL _sqrt
	LDS  R26,_S
	LDS  R27,_S+1
	LDS  R24,_S+2
	LDS  R25,_S+3
	CALL __DIVF21
	CALL __PUTPARD1
	CALL _atan
	LDS  R26,_L
	LDS  R27,_L+1
	LDS  R24,_L+2
	LDS  R25,_L+3
	CALL __ADDF12
	STS  _A5,R30
	STS  _A5+1,R31
	STS  _A5+2,R22
	STS  _A5+3,R23
;     166   S = V / sqrt(U);
	LDS  R30,_U
	LDS  R31,_U+1
	LDS  R22,_U+2
	LDS  R23,_U+3
	CALL __PUTPARD1
	CALL _sqrt
	LDS  R26,_V
	LDS  R27,_V+1
	LDS  R24,_V+2
	LDS  R25,_V+3
	CALL __DIVF21
	STS  _S,R30
	STS  _S+1,R31
	STS  _S+2,R22
	STS  _S+3,R23
;     167   D5 = atan(S / sqrt(1 - S * S));
	LDS  R26,_S
	LDS  R27,_S+1
	LDS  R24,_S+2
	LDS  R25,_S+3
	CALL __MULF12
	__GETD2N 0x3F800000
	CALL __SWAPD12
	CALL __SUBF12
	CALL __PUTPARD1
	CALL _sqrt
	LDS  R26,_S
	LDS  R27,_S+1
	LDS  R24,_S+2
	LDS  R25,_S+3
	CALL __DIVF21
	CALL __PUTPARD1
	CALL _atan
	STS  _D5,R30
	STS  _D5+1,R31
	STS  _D5+2,R22
	STS  _D5+3,R23
;     168   R5 = 1.00021 * sqrt(U);
	LDS  R30,_U
	LDS  R31,_U+1
	LDS  R22,_U+2
	LDS  R23,_U+3
	CALL __PUTPARD1
	CALL _sqrt
	__GETD2N 0x3F8006E2
	CALL __MULF12
	STS  _R5,R30
	STS  _R5+1,R31
	STS  _R5+2,R22
	STS  _R5+3,R23
;     169 }
	RET
;     170 
;     171 
;     172 void PossibleEvents(int Hour)
;     173 {
_PossibleEvents:
;     174   st = 0;
;	Hour -> Y+0
	CLT
	BLD  R2,0
;     175   L0 = T0 + Hour * K1;
	LDI  R30,LOW(_K1*2)
	LDI  R31,HIGH(_K1*2)
	CALL __GETD1PF
	LD   R26,Y
	LDD  R27,Y+1
	CALL __CWD2
	CALL __CDF2
	CALL __MULF12
	LDS  R26,_T0
	LDS  R27,_T0+1
	LDS  R24,_T0+2
	LDS  R25,_T0+3
	CALL __ADDF12
	STS  _L0,R30
	STS  _L0+1,R31
	STS  _L0+2,R22
	STS  _L0+3,R23
;     176   L2 = L0 + K1;
	LDI  R30,LOW(_K1*2)
	LDI  R31,HIGH(_K1*2)
	CALL __GETD1PF
	LDS  R26,_L0
	LDS  R27,_L0+1
	LDS  R24,_L0+2
	LDS  R25,_L0+3
	CALL __ADDF12
	STS  _L2,R30
	STS  _L2+1,R31
	STS  _L2+2,R22
	STS  _L2+3,R23
;     177   H0 = L0 - A0;
	LDS  R26,_A0
	LDS  R27,_A0+1
	LDS  R24,_A0+2
	LDS  R25,_A0+3
	LDS  R30,_L0
	LDS  R31,_L0+1
	LDS  R22,_L0+2
	LDS  R23,_L0+3
	CALL __SUBF12
	STS  _H0,R30
	STS  _H0+1,R31
	STS  _H0+2,R22
	STS  _H0+3,R23
;     178   H2 = L2 - A2;
	LDS  R26,_A2
	LDS  R27,_A2+1
	LDS  R24,_A2+2
	LDS  R25,_A2+3
	LDS  R30,_L2
	LDS  R31,_L2+1
	LDS  R22,_L2+2
	LDS  R23,_L2+3
	CALL __SUBF12
	STS  _H2,R30
	STS  _H2+1,R31
	STS  _H2+2,R22
	STS  _H2+3,R23
;     179   H1 = (H2 + H0) / 2; //  ,
	LDS  R30,_H0
	LDS  R31,_H0+1
	LDS  R22,_H0+2
	LDS  R23,_H0+3
	LDS  R26,_H2
	LDS  R27,_H2+1
	LDS  R24,_H2+2
	LDS  R25,_H2+3
	CALL __ADDF12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x40000000
	CALL __DIVF21
	STS  _H1,R30
	STS  _H1+1,R31
	STS  _H1+2,R22
	STS  _H1+3,R23
;     180   D1 = (D2 + D0) / 2; //   
	LDS  R30,_D0
	LDS  R31,_D0+1
	LDS  R22,_D0+2
	LDS  R23,_D0+3
	LDS  R26,_D2
	LDS  R27,_D2+1
	LDS  R24,_D2+2
	LDS  R25,_D2+3
	CALL __ADDF12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x40000000
	CALL __DIVF21
	STS  _D1,R30
	STS  _D1+1,R31
	STS  _D1+2,R22
	STS  _D1+3,R23
;     181   if (Hour <= 0) {V0 = S * sin(D0) + C * cos(D0) * cos(H0) - Z;};
	LD   R26,Y
	LDD  R27,Y+1
	CALL __CPW02
	BRGE PC+3
	JMP _0x15
	LDS  R30,_D0
	LDS  R31,_D0+1
	LDS  R22,_D0+2
	LDS  R23,_D0+3
	CALL __PUTPARD1
	CALL _sin
	LDS  R26,_S
	LDS  R27,_S+1
	LDS  R24,_S+2
	LDS  R25,_S+3
	CALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_D0
	LDS  R31,_D0+1
	LDS  R22,_D0+2
	LDS  R23,_D0+3
	CALL __PUTPARD1
	CALL _cos
	LDS  R26,_C
	LDS  R27,_C+1
	LDS  R24,_C+2
	LDS  R25,_C+3
	CALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_H0
	LDS  R31,_H0+1
	LDS  R22,_H0+2
	LDS  R23,_H0+3
	CALL __PUTPARD1
	CALL _cos
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDF12
	LDS  R26,_Z
	LDS  R27,_Z+1
	LDS  R24,_Z+2
	LDS  R25,_Z+3
	CALL __SUBF12
	STS  _V0,R30
	STS  _V0+1,R31
	STS  _V0+2,R22
	STS  _V0+3,R23
_0x15:
;     182   V2 = S * sin(D2) + C * cos(D2) * cos(H2) - Z;
	LDS  R30,_D2
	LDS  R31,_D2+1
	LDS  R22,_D2+2
	LDS  R23,_D2+3
	CALL __PUTPARD1
	CALL _sin
	LDS  R26,_S
	LDS  R27,_S+1
	LDS  R24,_S+2
	LDS  R25,_S+3
	CALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_D2
	LDS  R31,_D2+1
	LDS  R22,_D2+2
	LDS  R23,_D2+3
	CALL __PUTPARD1
	CALL _cos
	LDS  R26,_C
	LDS  R27,_C+1
	LDS  R24,_C+2
	LDS  R25,_C+3
	CALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_H2
	LDS  R31,_H2+1
	LDS  R22,_H2+2
	LDS  R23,_H2+3
	CALL __PUTPARD1
	CALL _cos
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDF12
	LDS  R26,_Z
	LDS  R27,_Z+1
	LDS  R24,_Z+2
	LDS  R25,_Z+3
	CALL __SUBF12
	STS  _V2,R30
	STS  _V2+1,R31
	STS  _V2+2,R22
	STS  _V2+3,R23
;     183   if (Sgn(V0) == Sgn(V2)) {goto end;};
	LDS  R30,_V0
	LDS  R31,_V0+1
	LDS  R22,_V0+2
	LDS  R23,_V0+3
	CALL __PUTPARD1
	CALL _Sgn
	PUSH R31
	PUSH R30
	LDS  R30,_V2
	LDS  R31,_V2+1
	LDS  R22,_V2+2
	LDS  R23,_V2+3
	CALL __PUTPARD1
	CALL _Sgn
	POP  R26
	POP  R27
	CP   R30,R26
	CPC  R31,R27
	BRNE _0x16
	RJMP _0x17
_0x16:
;     184   V1 = S * sin(D1) + C * cos(D1) * cos(H1) - Z;
	LDS  R30,_D1
	LDS  R31,_D1+1
	LDS  R22,_D1+2
	LDS  R23,_D1+3
	CALL __PUTPARD1
	CALL _sin
	LDS  R26,_S
	LDS  R27,_S+1
	LDS  R24,_S+2
	LDS  R25,_S+3
	CALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_D1
	LDS  R31,_D1+1
	LDS  R22,_D1+2
	LDS  R23,_D1+3
	CALL __PUTPARD1
	CALL _cos
	LDS  R26,_C
	LDS  R27,_C+1
	LDS  R24,_C+2
	LDS  R25,_C+3
	CALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_H1
	LDS  R31,_H1+1
	LDS  R22,_H1+2
	LDS  R23,_H1+3
	CALL __PUTPARD1
	CALL _cos
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDF12
	LDS  R26,_Z
	LDS  R27,_Z+1
	LDS  R24,_Z+2
	LDS  R25,_Z+3
	CALL __SUBF12
	STS  _V1,R30
	STS  _V1+1,R31
	STS  _V1+2,R22
	STS  _V1+3,R23
;     185   A = 2 * V2 - 4 * V1 + 2 * V0;
	LDS  R30,_V2
	LDS  R31,_V2+1
	LDS  R22,_V2+2
	LDS  R23,_V2+3
	__GETD2N 0x40000000
	CALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_V1
	LDS  R31,_V1+1
	LDS  R22,_V1+2
	LDS  R23,_V1+3
	__GETD2N 0x40800000
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __SWAPD12
	CALL __SUBF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_V0
	LDS  R31,_V0+1
	LDS  R22,_V0+2
	LDS  R23,_V0+3
	__GETD2N 0x40000000
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDF12
	STS  _A,R30
	STS  _A+1,R31
	STS  _A+2,R22
	STS  _A+3,R23
;     186   B = 4 * V1 - 3 * V0 - V2;
	LDS  R30,_V1
	LDS  R31,_V1+1
	LDS  R22,_V1+2
	LDS  R23,_V1+3
	__GETD2N 0x40800000
	CALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_V0
	LDS  R31,_V0+1
	LDS  R22,_V0+2
	LDS  R23,_V0+3
	__GETD2N 0x40400000
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __SWAPD12
	CALL __SUBF12
	LDS  R26,_V2
	LDS  R27,_V2+1
	LDS  R24,_V2+2
	LDS  R25,_V2+3
	CALL __SUBF12
	STS  _B,R30
	STS  _B+1,R31
	STS  _B+2,R22
	STS  _B+3,R23
;     187   D = B * B - 4 * A * V0;
	LDS  R26,_B
	LDS  R27,_B+1
	LDS  R24,_B+2
	LDS  R25,_B+3
	CALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_A
	LDS  R31,_A+1
	LDS  R22,_A+2
	LDS  R23,_A+3
	__GETD2N 0x40800000
	CALL __MULF12
	LDS  R26,_V0
	LDS  R27,_V0+1
	LDS  R24,_V0+2
	LDS  R25,_V0+3
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __SWAPD12
	CALL __SUBF12
	STS  _D,R30
	STS  _D+1,R31
	STS  _D+2,R22
	STS  _D+3,R23
;     188   if (D < 0) {goto end;};
	LDS  R26,_D
	LDS  R27,_D+1
	LDS  R24,_D+2
	LDS  R25,_D+3
	CALL __CPD20
	BRGE _0x18
	RJMP _0x17
_0x18:
;     189   D = sqrt(D);
	LDS  R30,_D
	LDS  R31,_D+1
	LDS  R22,_D+2
	LDS  R23,_D+3
	CALL __PUTPARD1
	CALL _sqrt
	STS  _D,R30
	STS  _D+1,R31
	STS  _D+2,R22
	STS  _D+3,R23
;     190   E = (-B + D) / (2 * A);
	LDS  R30,_B
	LDS  R31,_B+1
	LDS  R22,_B+2
	LDS  R23,_B+3
	CALL __ANEGF1
	LDS  R26,_D
	LDS  R27,_D+1
	LDS  R24,_D+2
	LDS  R25,_D+3
	CALL __ADDF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_A
	LDS  R31,_A+1
	LDS  R22,_A+2
	LDS  R23,_A+3
	__GETD2N 0x40000000
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __DIVF21
	STS  _E,R30
	STS  _E+1,R31
	STS  _E+2,R22
	STS  _E+3,R23
;     191   if ((E > 1) || (E < 0)) {E = (-B - D) / (2 * A);};
	LDS  R26,_E
	LDS  R27,_E+1
	LDS  R24,_E+2
	LDS  R25,_E+3
	__GETD1N 0x3F800000
	CALL __CMPF12
	BREQ PC+4
	BRCS PC+3
	JMP  _0x1A
	CALL __CPD20
	BRGE _0x19
_0x1A:
	LDS  R30,_B
	LDS  R31,_B+1
	LDS  R22,_B+2
	LDS  R23,_B+3
	CALL __ANEGF1
	LDS  R26,_D
	LDS  R27,_D+1
	LDS  R24,_D+2
	LDS  R25,_D+3
	CALL __SUBF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_A
	LDS  R31,_A+1
	LDS  R22,_A+2
	LDS  R23,_A+3
	__GETD2N 0x40000000
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __DIVF21
	STS  _E,R30
	STS  _E+1,R31
	STS  _E+2,R22
	STS  _E+3,R23
_0x19:
;     192   T3 = Hour + E + 1 / 120; // 
	LDS  R30,_E
	LDS  R31,_E+1
	LDS  R22,_E+2
	LDS  R23,_E+3
	LD   R26,Y
	LDD  R27,Y+1
	CALL __CWD2
	CALL __CDF2
	CALL __ADDF12
	__GETD2N 0x0
	CALL __ADDF12
	STS  _T3,R30
	STS  _T3+1,R31
	STS  _T3+2,R22
	STS  _T3+3,R23
;     193   H3 = Trunc(T3);
	CALL __PUTPARD1
	CALL _Trunc
	STS  _H3,R30
	STS  _H3+1,R31
	STS  _H3+2,R22
	STS  _H3+3,R23
;     194   M3 = Trunc((T3 - H3) * 60);
	LDS  R26,_T3
	LDS  R27,_T3+1
	LDS  R24,_T3+2
	LDS  R25,_T3+3
	CALL __CDF1
	CALL __SWAPD12
	CALL __SUBF12
	__GETD2N 0x42700000
	CALL __MULF12
	CALL __PUTPARD1
	CALL _Trunc
	STS  _M3,R30
	STS  _M3+1,R31
	STS  _M3+2,R22
	STS  _M3+3,R23
;     195   if ((V0 < 0) && (V2 > 0)) {HH[0]=H3; MM[0]=M3; M8 = 1; st=1;}
	LDS  R26,_V0
	LDS  R27,_V0+1
	LDS  R24,_V0+2
	LDS  R25,_V0+3
	CALL __CPD20
	BRGE _0x1D
	LDS  R26,_V2
	LDS  R27,_V2+1
	LDS  R24,_V2+2
	LDS  R25,_V2+3
	CALL __CPD02
	BRLT _0x1E
_0x1D:
	RJMP _0x1C
_0x1E:
	LDS  R30,_H3
	LDS  R31,_H3+1
	STS  _HH,R30
	STS  _HH+1,R31
	LDS  R30,_M3
	LDS  R31,_M3+1
	STS  _MM,R30
	STS  _MM+1,R31
	__GETD1N 0x3F800000
	STS  _M8,R30
	STS  _M8+1,R31
	STS  _M8+2,R22
	STS  _M8+3,R23
	SET
	BLD  R2,0
;     196   if ((V0 > 0) && (V2 < 0)) {HH[1]=H3; MM[1]=M3; W8 = 1; st=0;}
_0x1C:
	LDS  R26,_V0
	LDS  R27,_V0+1
	LDS  R24,_V0+2
	LDS  R25,_V0+3
	CALL __CPD02
	BRGE _0x20
	LDS  R26,_V2
	LDS  R27,_V2+1
	LDS  R24,_V2+2
	LDS  R25,_V2+3
	CALL __CPD20
	BRLT _0x21
_0x20:
	RJMP _0x1F
_0x21:
	__POINTW2MN _HH,2
	LDS  R30,_H3
	LDS  R31,_H3+1
	LDS  R22,_H3+2
	LDS  R23,_H3+3
	ST   X+,R30
	ST   X,R31
	__POINTW2MN _MM,2
	LDS  R30,_M3
	LDS  R31,_M3+1
	LDS  R22,_M3+2
	LDS  R23,_M3+3
	ST   X+,R30
	ST   X,R31
	__GETD1N 0x3F800000
	STS  _W8,R30
	STS  _W8+1,R31
	STS  _W8+2,R22
	STS  _W8+3,R23
	CLT
	BLD  R2,0
;     197 end:
_0x1F:
_0x17:
;     198 }
	ADIW R28,2
	RET
;     199 
;     200 
;     201 void OutInform(void)
;     202 {
_OutInform:
;     203  if ((M8 = 0) && (W8 = 0))
	__GETD1N 0x0
	STS  _M8,R30
	STS  _M8+1,R31
	STS  _M8+2,R22
	STS  _M8+3,R23
	CALL __CPD10
	BREQ _0x23
	STS  _W8,R30
	STS  _W8+1,R31
	STS  _W8+2,R22
	STS  _W8+3,R23
	CALL __CPD10
	BRNE _0x24
_0x23:
	RJMP _0x22
_0x24:
;     204  {
;     205     if (V2 < 0) {st=-1;}
	LDS  R26,_V2
	LDS  R27,_V2+1
	LDS  R24,_V2+2
	LDS  R25,_V2+3
	CALL __CPD20
	BRGE _0x25
	SET
	BLD  R2,0
;     206 //      ListBox.Items.Add('    ');
;     207     if (V2 > 0) {st=1;}
_0x25:
	LDS  R26,_V2
	LDS  R27,_V2+1
	LDS  R24,_V2+2
	LDS  R25,_V2+3
	CALL __CPD02
	BRGE _0x26
	SET
	BLD  R2,0
;     208 //      ListBox.Items.Add('    ');
;     209  }
_0x26:
;     210   else
	RJMP _0x27
_0x22:
;     211   {
;     212     if (M8 == 0) {st=1;}
	LDS  R30,_M8
	LDS  R31,_M8+1
	LDS  R22,_M8+2
	LDS  R23,_M8+3
	CALL __CPD10
	BRNE _0x28
	SET
	BLD  R2,0
;     213 //      ListBox.Items.Add('      ');
;     214     if (W8 == 0) {st=-1;}
_0x28:
	LDS  R30,_W8
	LDS  R31,_W8+1
	LDS  R22,_W8+2
	LDS  R23,_W8+3
	CALL __CPD10
	BRNE _0x29
	SET
	BLD  R2,0
;     215 //      ListBox.Items.Add('      ');
;     216   }
_0x29:
_0x27:
;     217 }
	RET
;     218 
;     219 void show_info(void)
;     220 {
_show_info:
;     221   D = day;
	LDS  R30,_day
	LDS  R31,_day+1
	LDS  R22,_day+2
	LDS  R23,_day+3
	CALL __CDF1
	STS  _D,R30
	STS  _D+1,R31
	STS  _D+2,R22
	STS  _D+3,R23
;     222   L5 = L5 / 360;
	LDS  R26,_L5
	LDS  R27,_L5+1
	LDS  R24,_L5+2
	LDS  R25,_L5+3
	__GETD1N 0x43B40000
	CALL __DIVF21
	STS  _L5,R30
	STS  _L5+1,R31
	STS  _L5+2,R22
	STS  _L5+3,R23
;     223   Z0 = H / 24;
	LDS  R26,_H
	LDS  R27,_H+1
	LDS  R24,_H+2
	LDS  R25,_H+3
	__GETD1N 0x18
	CALL __DIVD21
	CALL __CDF1
	STS  _Z0,R30
	STS  _Z0+1,R31
	STS  _Z0+2,R22
	STS  _Z0+3,R23
;     224   Calendar();
	CALL _Calendar
;     225   T = (J - 2451545) + F;
	LDS  R26,_J
	LDS  R27,_J+1
	LDS  R24,_J+2
	LDS  R25,_J+3
	__GETD1N 0x4A15A164
	CALL __SWAPD12
	CALL __SUBF12
	LDS  R26,_F
	LDS  R27,_F+1
	LDS  R24,_F+2
	LDS  R25,_F+3
	CALL __ADDF12
	STS  _T,R30
	STS  _T+1,R31
	STS  _T+2,R22
	STS  _T+3,R23
;     226   TT = T / 36525 + 1; // TT - ,   1900.0
	LDS  R26,_T
	LDS  R27,_T+1
	LDS  R24,_T+2
	LDS  R25,_T+3
	__GETD1N 0x470EAD00
	CALL __DIVF21
	__GETD2N 0x3F800000
	CALL __ADDF12
	STS  _TT,R30
	STS  _TT+1,R31
	STS  _TT+2,R22
	STS  _TT+3,R23
;     227   GetTimeZone(); //   
	CALL _GetTimeZone
;     228   T = T + H;//Z0;
	LDS  R30,_H
	LDS  R31,_H+1
	LDS  R22,_H+2
	LDS  R23,_H+3
	LDS  R26,_T
	LDS  R27,_T+1
	LDS  R24,_T+2
	LDS  R25,_T+3
	CALL __CDF1
	CALL __ADDF12
	STS  _T,R30
	STS  _T+1,R31
	STS  _T+2,R22
	STS  _T+3,R23
;     229   PosOfSun(); //   
	CALL _PosOfSun
;     230   aA[0] = A5;
	LDS  R30,_A5
	LDS  R31,_A5+1
	LDS  R22,_A5+2
	LDS  R23,_A5+3
	STS  _aA,R30
	STS  _aA+1,R31
	STS  _aA+2,R22
	STS  _aA+3,R23
;     231   aD[0] = D5;
	LDS  R30,_D5
	LDS  R31,_D5+1
	LDS  R22,_D5+2
	LDS  R23,_D5+3
	STS  _aD,R30
	STS  _aD+1,R31
	STS  _aD+2,R22
	STS  _aD+3,R23
;     232   T = T + 1;
	LDS  R30,_T
	LDS  R31,_T+1
	LDS  R22,_T+2
	LDS  R23,_T+3
	__GETD2N 0x3F800000
	CALL __ADDF12
	STS  _T,R30
	STS  _T+1,R31
	STS  _T+2,R22
	STS  _T+3,R23
;     233   PosOfSun();
	CALL _PosOfSun
;     234   aA[1] = A5;
	__POINTW1MN _aA,4
	LDS  R26,_A5
	LDS  R27,_A5+1
	LDS  R24,_A5+2
	LDS  R25,_A5+3
	__PUTDZ2 0
;     235   aD[1] = D5;
	__POINTW1MN _aD,4
	LDS  R26,_D5
	LDS  R27,_D5+1
	LDS  R24,_D5+2
	LDS  R25,_D5+3
	__PUTDZ2 0
;     236   if (aA[1] < aA[0]) {aA[1] = aA[1] + P2;}
	__GETD2MN _aA,4
	LDS  R30,_aA
	LDS  R31,_aA+1
	LDS  R22,_aA+2
	LDS  R23,_aA+3
	CALL __CMPF12
	BRSH _0x2A
	__GETD2MN _aA,4
	LDI  R30,LOW(_P2*2)
	LDI  R31,HIGH(_P2*2)
	CALL __GETD1PF
	CALL __ADDF12
	__PUTD1MN _aA,4
;     237   Z1 = DR * 90.833; //  
_0x2A:
	LDI  R30,LOW(_DR*2)
	LDI  R31,HIGH(_DR*2)
	CALL __GETD1PF
	__GETD2N 0x42B5AA7F
	CALL __MULF12
	STS  _Z1,R30
	STS  _Z1+1,R31
	STS  _Z1+2,R22
	STS  _Z1+3,R23
;     238   S = sin(B5 * DR);
	LDI  R30,LOW(_DR*2)
	LDI  R31,HIGH(_DR*2)
	CALL __GETD1PF
	LDS  R26,_B5
	LDS  R27,_B5+1
	LDS  R24,_B5+2
	LDS  R25,_B5+3
	CALL __CDF2
	CALL __MULF12
	CALL __PUTPARD1
	CALL _sin
	STS  _S,R30
	STS  _S+1,R31
	STS  _S+2,R22
	STS  _S+3,R23
;     239   C = cos(B5 * DR);
	LDI  R30,LOW(_DR*2)
	LDI  R31,HIGH(_DR*2)
	CALL __GETD1PF
	LDS  R26,_B5
	LDS  R27,_B5+1
	LDS  R24,_B5+2
	LDS  R25,_B5+3
	CALL __CDF2
	CALL __MULF12
	CALL __PUTPARD1
	CALL _cos
	STS  _C,R30
	STS  _C+1,R31
	STS  _C+2,R22
	STS  _C+3,R23
;     240   Z = cos(Z1);
	LDS  R30,_Z1
	LDS  R31,_Z1+1
	LDS  R22,_Z1+2
	LDS  R23,_Z1+3
	CALL __PUTPARD1
	CALL _cos
	STS  _Z,R30
	STS  _Z+1,R31
	STS  _Z+2,R22
	STS  _Z+3,R23
;     241   M8 = 0;
	__GETD1N 0x0
	STS  _M8,R30
	STS  _M8+1,R31
	STS  _M8+2,R22
	STS  _M8+3,R23
;     242   W8 = 0;
	STS  _W8,R30
	STS  _W8+1,R31
	STS  _W8+2,R22
	STS  _W8+3,R23
;     243   A0 = aA[0];
	LDS  R30,_aA
	LDS  R31,_aA+1
	LDS  R22,_aA+2
	LDS  R23,_aA+3
	STS  _A0,R30
	STS  _A0+1,R31
	STS  _A0+2,R22
	STS  _A0+3,R23
;     244   D0 = aD[0];
	LDS  R30,_aD
	LDS  R31,_aD+1
	LDS  R22,_aD+2
	LDS  R23,_aD+3
	STS  _D0,R30
	STS  _D0+1,R31
	STS  _D0+2,R22
	STS  _D0+3,R23
;     245   DA = aA[1] - aA[0];
	__GETD1MN _aA,4
	LDS  R26,_aA
	LDS  R27,_aA+1
	LDS  R24,_aA+2
	LDS  R25,_aA+3
	CALL __SUBF12
	STS  _DA,R30
	STS  _DA+1,R31
	STS  _DA+2,R22
	STS  _DA+3,R23
;     246   DD = aD[1] - aD[0];
	__GETD1MN _aD,4
	LDS  R26,_aD
	LDS  R27,_aD+1
	LDS  R24,_aD+2
	LDS  R25,_aD+3
	CALL __SUBF12
	STS  _DD,R30
	STS  _DD+1,R31
	STS  _DD+2,R22
	STS  _DD+3,R23
;     247   for (C0 = 0; C0 < 24; C0++)
	LDI  R30,0
	STS  _C0,R30
	STS  _C0+1,R30
	STS  _C0+2,R30
	STS  _C0+3,R30
_0x2C:
	LDS  R26,_C0
	LDS  R27,_C0+1
	LDS  R24,_C0+2
	LDS  R25,_C0+3
	__CPD2N 0x18
	BRLT PC+3
	JMP _0x2D
;     248   {
;     249     P = (C0 + 1) / 24;
	LDS  R30,_C0
	LDS  R31,_C0+1
	LDS  R22,_C0+2
	LDS  R23,_C0+3
	__ADDD1N 1
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x18
	CALL __DIVD21
	CALL __CDF1
	STS  _P,R30
	STS  _P+1,R31
	STS  _P+2,R22
	STS  _P+3,R23
;     250     A2 = aA[0] + P * DA;
	LDS  R30,_DA
	LDS  R31,_DA+1
	LDS  R22,_DA+2
	LDS  R23,_DA+3
	LDS  R26,_P
	LDS  R27,_P+1
	LDS  R24,_P+2
	LDS  R25,_P+3
	CALL __MULF12
	LDS  R26,_aA
	LDS  R27,_aA+1
	LDS  R24,_aA+2
	LDS  R25,_aA+3
	CALL __ADDF12
	STS  _A2,R30
	STS  _A2+1,R31
	STS  _A2+2,R22
	STS  _A2+3,R23
;     251     D2 = aD[0] + P * DD;
	LDS  R30,_DD
	LDS  R31,_DD+1
	LDS  R22,_DD+2
	LDS  R23,_DD+3
	LDS  R26,_P
	LDS  R27,_P+1
	LDS  R24,_P+2
	LDS  R25,_P+3
	CALL __MULF12
	LDS  R26,_aD
	LDS  R27,_aD+1
	LDS  R24,_aD+2
	LDS  R25,_aD+3
	CALL __ADDF12
	STS  _D2,R30
	STS  _D2+1,R31
	STS  _D2+2,R22
	STS  _D2+3,R23
;     252     PossibleEvents(C0);
	LDS  R30,_C0
	LDS  R31,_C0+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _PossibleEvents
;     253     if (st != 0) {sun_info();}
	SBRS R2,0
	RJMP _0x2E
	CALL _sun_info
;     254     A0 = A2;
_0x2E:
	LDS  R30,_A2
	LDS  R31,_A2+1
	LDS  R22,_A2+2
	LDS  R23,_A2+3
	STS  _A0,R30
	STS  _A0+1,R31
	STS  _A0+2,R22
	STS  _A0+3,R23
;     255     D0 = D2;
	LDS  R30,_D2
	LDS  R31,_D2+1
	LDS  R22,_D2+2
	LDS  R23,_D2+3
	STS  _D0,R30
	STS  _D0+1,R31
	STS  _D0+2,R22
	STS  _D0+3,R23
;     256     V0 = V2;
	LDS  R30,_V2
	LDS  R31,_V2+1
	LDS  R22,_V2+2
	LDS  R23,_V2+3
	STS  _V0,R30
	STS  _V0+1,R31
	STS  _V0+2,R22
	STS  _V0+3,R23
;     257   }
	LDS  R30,_C0
	LDS  R31,_C0+1
	LDS  R22,_C0+2
	LDS  R23,_C0+3
	__SUBD1N -1
	STS  _C0,R30
	STS  _C0+1,R31
	STS  _C0+2,R22
	STS  _C0+3,R23
	RJMP _0x2C
_0x2D:
;     258   OutInform();
	CALL _OutInform
;     259 
;     260 //  ListBox.Items.Add(''); //  
;     261   if (st==0) {light_on;} else
	SBRC R2,0
	RJMP _0x2F
	SBI  0x15,0
	RJMP _0x32
_0x2F:
;     262   if (st==1) {light_off;}
	SBRC R2,0
	CBI  0x15,0
;     263 }
_0x32:
	RET
;     264 
;     265 void clock(void)
;     266 {
_clock:
;     267   if (msec>=1)
	LDS  R26,_msec
	LDS  R27,_msec+1
	LDS  R24,_msec+2
	LDS  R25,_msec+3
	__CPD2N 0x1
	BRLT _0x36
;     268   {
;     269     msec=0; sec++;
	LDI  R30,0
	STS  _msec,R30
	STS  _msec+1,R30
	STS  _msec+2,R30
	STS  _msec+3,R30
	LDS  R30,_sec
	LDS  R31,_sec+1
	LDS  R22,_sec+2
	LDS  R23,_sec+3
	__SUBD1N -1
	STS  _sec,R30
	STS  _sec+1,R31
	STS  _sec+2,R22
	STS  _sec+3,R23
;     270     if (delim==':') {delim=' ';}
	LDI  R30,LOW(58)
	CP   R30,R4
	BRNE _0x37
	LDI  R30,LOW(32)
	RJMP _0x5D
;     271     else {delim=':';};
_0x37:
	LDI  R30,LOW(58)
_0x5D:
	MOV  R4,R30
;     272   };
_0x36:
;     273   // if (cc==150) {msec++; cc=0;};
;     274  // if (msec==100) {msec=0; sec++;};
;     275  //if (sec==60) {sec=0; mins++;};
;     276  // if (mins==60) {mins=0; hr++;};
;     277  // if (hr==24) {day++; hr=0;};
;     278  // if (day==days_month[m]) {m++; day=1;};
;     279 
;     280 
;     281   if (sec==1) {sec=0; mins++;};
	LDS  R26,_sec
	LDS  R27,_sec+1
	LDS  R24,_sec+2
	LDS  R25,_sec+3
	__CPD2N 0x1
	BRNE _0x39
	LDI  R30,0
	STS  _sec,R30
	STS  _sec+1,R30
	STS  _sec+2,R30
	STS  _sec+3,R30
	LDS  R30,_mins
	LDS  R31,_mins+1
	LDS  R22,_mins+2
	LDS  R23,_mins+3
	__SUBD1N -1
	STS  _mins,R30
	STS  _mins+1,R31
	STS  _mins+2,R22
	STS  _mins+3,R23
_0x39:
;     282   if (mins==1) {mins=0; hr++;};
	LDS  R26,_mins
	LDS  R27,_mins+1
	LDS  R24,_mins+2
	LDS  R25,_mins+3
	__CPD2N 0x1
	BRNE _0x3A
	LDI  R30,0
	STS  _mins,R30
	STS  _mins+1,R30
	STS  _mins+2,R30
	STS  _mins+3,R30
	LDS  R30,_hr
	LDS  R31,_hr+1
	LDS  R22,_hr+2
	LDS  R23,_hr+3
	__SUBD1N -1
	STS  _hr,R30
	STS  _hr+1,R31
	STS  _hr+2,R22
	STS  _hr+3,R23
_0x3A:
;     283   if (hr==24) {day++; hr=0;};
	LDS  R26,_hr
	LDS  R27,_hr+1
	LDS  R24,_hr+2
	LDS  R25,_hr+3
	__CPD2N 0x18
	BRNE _0x3B
	LDS  R30,_day
	LDS  R31,_day+1
	LDS  R22,_day+2
	LDS  R23,_day+3
	__SUBD1N -1
	STS  _day,R30
	STS  _day+1,R31
	STS  _day+2,R22
	STS  _day+3,R23
	LDI  R30,0
	STS  _hr,R30
	STS  _hr+1,R30
	STS  _hr+2,R30
	STS  _hr+3,R30
_0x3B:
;     284   if (day==days_month[M-1]) {M++; day=1;};
	LDS  R30,_M
	LDS  R31,_M+1
	LDS  R22,_M+2
	LDS  R23,_M+3
	__SUBD1N 1
	LDI  R26,LOW(_days_month*2)
	LDI  R27,HIGH(_days_month*2)
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	CALL __GETW1PF
	LDS  R26,_day
	LDS  R27,_day+1
	LDS  R24,_day+2
	LDS  R25,_day+3
	CLR  R22
	CLR  R23
	CALL __CPD12
	BRNE _0x3C
	LDS  R30,_M
	LDS  R31,_M+1
	LDS  R22,_M+2
	LDS  R23,_M+3
	__SUBD1N -1
	STS  _M,R30
	STS  _M+1,R31
	STS  _M+2,R22
	STS  _M+3,R23
	__GETD1N 0x1
	STS  _day,R30
	STS  _day+1,R31
	STS  _day+2,R22
	STS  _day+3,R23
_0x3C:
;     285   if (M==12) {M=0; Y++;};
	LDS  R26,_M
	LDS  R27,_M+1
	LDS  R24,_M+2
	LDS  R25,_M+3
	__CPD2N 0xC
	BRNE _0x3D
	LDI  R30,0
	STS  _M,R30
	STS  _M+1,R30
	STS  _M+2,R30
	STS  _M+3,R30
	LDS  R30,_Y
	LDS  R31,_Y+1
	LDS  R22,_Y+2
	LDS  R23,_Y+3
	__SUBD1N -1
	STS  _Y,R30
	STS  _Y+1,R31
	STS  _Y+2,R22
	STS  _Y+3,R23
_0x3D:
;     286   lcd_gotoxy(0,1);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_gotoxy
;     287   lcd_putchar (hr/10%10+0x30);
	LDS  R26,_hr
	LDS  R27,_hr+1
	LDS  R24,_hr+2
	LDS  R25,_hr+3
	__GETD1N 0xA
	CALL __DIVD21
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	CALL __MODD21
	__ADDD1N 48
	ST   -Y,R30
	CALL _lcd_putchar
;     288   lcd_putchar (hr%10+0x30);
	LDS  R26,_hr
	LDS  R27,_hr+1
	LDS  R24,_hr+2
	LDS  R25,_hr+3
	__GETD1N 0xA
	CALL __MODD21
	__ADDD1N 48
	ST   -Y,R30
	CALL _lcd_putchar
;     289   lcd_putchar (delim);
	ST   -Y,R4
	CALL _lcd_putchar
;     290   lcd_putchar (mins/10%10+0x30);
	LDS  R26,_mins
	LDS  R27,_mins+1
	LDS  R24,_mins+2
	LDS  R25,_mins+3
	__GETD1N 0xA
	CALL __DIVD21
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	CALL __MODD21
	__ADDD1N 48
	ST   -Y,R30
	CALL _lcd_putchar
;     291   lcd_putchar (mins%10+0x30);
	LDS  R26,_mins
	LDS  R27,_mins+1
	LDS  R24,_mins+2
	LDS  R25,_mins+3
	__GETD1N 0xA
	CALL __MODD21
	__ADDD1N 48
	ST   -Y,R30
	CALL _lcd_putchar
;     292 //        lcd_putsf (":");
;     293 //          lcd_putchar ((msec/10)%10+0x30);
;     294 //           lcd_putchar (msec%10+0x30);
;     295   lcd_putsf (" ");
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_putsf
;     296   lcd_putchar ((day/10)%10+0x30);
	LDS  R26,_day
	LDS  R27,_day+1
	LDS  R24,_day+2
	LDS  R25,_day+3
	__GETD1N 0xA
	CALL __DIVD21
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	CALL __MODD21
	__ADDD1N 48
	ST   -Y,R30
	CALL _lcd_putchar
;     297   lcd_putchar (day%10+0x30);
	LDS  R26,_day
	LDS  R27,_day+1
	LDS  R24,_day+2
	LDS  R25,_day+3
	__GETD1N 0xA
	CALL __MODD21
	__ADDD1N 48
	ST   -Y,R30
	CALL _lcd_putchar
;     298   lcd_putsf ("/");
	__POINTW1FN _0,2
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_putsf
;     299   lcd_putchar ((M/10)%10+0x30);
	LDS  R26,_M
	LDS  R27,_M+1
	LDS  R24,_M+2
	LDS  R25,_M+3
	__GETD1N 0xA
	CALL __DIVD21
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	CALL __MODD21
	__ADDD1N 48
	ST   -Y,R30
	CALL _lcd_putchar
;     300   lcd_putchar (M%10+0x30);
	LDS  R26,_M
	LDS  R27,_M+1
	LDS  R24,_M+2
	LDS  R25,_M+3
	__GETD1N 0xA
	CALL __MODD21
	__ADDD1N 48
	ST   -Y,R30
	CALL _lcd_putchar
;     301   lcd_putsf ("/");
	__POINTW1FN _0,2
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_putsf
;     302   lcd_putchar ((Y/1000)%10+0x30);
	LDS  R26,_Y
	LDS  R27,_Y+1
	LDS  R24,_Y+2
	LDS  R25,_Y+3
	__GETD1N 0x3E8
	CALL __DIVD21
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	CALL __MODD21
	__ADDD1N 48
	ST   -Y,R30
	CALL _lcd_putchar
;     303   lcd_putchar ((Y/100)%10+0x30);
	LDS  R26,_Y
	LDS  R27,_Y+1
	LDS  R24,_Y+2
	LDS  R25,_Y+3
	__GETD1N 0x64
	CALL __DIVD21
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	CALL __MODD21
	__ADDD1N 48
	ST   -Y,R30
	CALL _lcd_putchar
;     304   lcd_putchar ((Y/10)%10+0x30);
	LDS  R26,_Y
	LDS  R27,_Y+1
	LDS  R24,_Y+2
	LDS  R25,_Y+3
	__GETD1N 0xA
	CALL __DIVD21
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	CALL __MODD21
	__ADDD1N 48
	ST   -Y,R30
	CALL _lcd_putchar
;     305   lcd_putchar (Y%10+0x30);
	LDS  R26,_Y
	LDS  R27,_Y+1
	LDS  R24,_Y+2
	LDS  R25,_Y+3
	__GETD1N 0xA
	CALL __MODD21
	__ADDD1N 48
	ST   -Y,R30
	CALL _lcd_putchar
;     306   if ((hr>HH[0]) && (mins>MM[0])) {st=0;}
	LDS  R30,_HH
	LDS  R31,_HH+1
	LDS  R26,_hr
	LDS  R27,_hr+1
	LDS  R24,_hr+2
	LDS  R25,_hr+3
	CLR  R22
	CLR  R23
	CALL __CPD12
	BRGE _0x3F
	LDS  R30,_MM
	LDS  R31,_MM+1
	LDS  R26,_mins
	LDS  R27,_mins+1
	LDS  R24,_mins+2
	LDS  R25,_mins+3
	CLR  R22
	CLR  R23
	CALL __CPD12
	BRLT _0x40
_0x3F:
	RJMP _0x3E
_0x40:
	CLT
	BLD  R2,0
;     307   if ((hr>HH[1]) && (mins>MM[1])) {st=1;}
_0x3E:
	__GETW1MN _HH,2
	LDS  R26,_hr
	LDS  R27,_hr+1
	LDS  R24,_hr+2
	LDS  R25,_hr+3
	CLR  R22
	CLR  R23
	CALL __CPD12
	BRGE _0x42
	__GETW1MN _MM,2
	LDS  R26,_mins
	LDS  R27,_mins+1
	LDS  R24,_mins+2
	LDS  R25,_mins+3
	CLR  R22
	CLR  R23
	CALL __CPD12
	BRLT _0x43
_0x42:
	RJMP _0x41
_0x43:
	SET
	BLD  R2,0
;     308  }
_0x41:
	RET
;     309 
;     310 
;     311 void main(void)
;     312 {
_main:
;     313 // Declare your local variables here
;     314 
;     315 // Input/Output Ports initialization
;     316 // Port A initialization
;     317 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=Out Func1=Out Func0=Out
;     318 // State7=0 State6=0 State5=0 State4=0 State3=T State2=0 State1=0 State0=0
;     319 PORTA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
;     320 DDRA=0xF7;
	LDI  R30,LOW(247)
	OUT  0x1A,R30
;     321 
;     322 // Port B initialization
;     323 // Func7=In Func6=In Func5=In Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
;     324 // State7=T State6=T State5=T State4=1 State3=1 State2=1 State1=1 State0=1
;     325 PORTB=0x1F;
	LDI  R30,LOW(31)
	OUT  0x18,R30
;     326 DDRB=0x1F;
	OUT  0x17,R30
;     327 
;     328 // Port C initialization
;     329 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=Out
;     330 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=0
;     331 PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x15,R30
;     332 DDRC=0x01;
	LDI  R30,LOW(1)
	OUT  0x14,R30
;     333 
;     334 // Port D initialization
;     335 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
;     336 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
;     337 PORTD=0x00;
	LDI  R30,LOW(0)
	OUT  0x12,R30
;     338 DDRD=0x00;
	OUT  0x11,R30
;     339 
;     340 
;     341 // Timer/Counter 0 initialization
;     342 // Clock source: System Clock
;     343 // Clock value: 1000,000 kHz
;     344 // Mode: Normal top=FFh
;     345 // OC0 output: Disconnected
;     346 TCCR0=0x02;
	LDI  R30,LOW(2)
	OUT  0x33,R30
;     347 TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x32,R30
;     348 OCR0=0x00;
	OUT  0x3C,R30
;     349 
;     350 // Timer/Counter 1 initialization
;     351 // Clock source: System Clock
;     352 // Clock value: Timer 1 Stopped
;     353 // Mode: Normal top=FFFFh
;     354 // OC1A output: Discon.
;     355 // OC1B output: Discon.
;     356 // Noise Canceler: Off
;     357 // Input Capture on Falling Edge
;     358 // Timer 1 Overflow Interrupt: Off
;     359 // Input Capture Interrupt: Off
;     360 // Compare A Match Interrupt: Off
;     361 // Compare B Match Interrupt: Off
;     362 TCCR1A=0x00;
	OUT  0x2F,R30
;     363 TCCR1B=0x00;
	OUT  0x2E,R30
;     364 TCNT1H=0x00;
	OUT  0x2D,R30
;     365 TCNT1L=0x00;
	OUT  0x2C,R30
;     366 ICR1H=0x00;
	OUT  0x27,R30
;     367 ICR1L=0x00;
	OUT  0x26,R30
;     368 OCR1AH=0x00;
	OUT  0x2B,R30
;     369 OCR1AL=0x00;
	OUT  0x2A,R30
;     370 OCR1BH=0x00;
	OUT  0x29,R30
;     371 OCR1BL=0x00;
	OUT  0x28,R30
;     372 
;     373 // Timer/Counter 2 initialization
;     374 // Clock source: System Clock
;     375 // Clock value: Timer 2 Stopped
;     376 // Mode: Normal top=FFh
;     377 // OC2 output: Disconnected
;     378 ASSR=0x00;
	OUT  0x22,R30
;     379 TCCR2=0x00;
	OUT  0x25,R30
;     380 TCNT2=0x00;
	OUT  0x24,R30
;     381 OCR2=0x00;
	OUT  0x23,R30
;     382 
;     383 // External Interrupt(s) initialization
;     384 // INT0: Off
;     385 // INT1: Off
;     386 // INT2: Off
;     387 MCUCR=0x00;
	OUT  0x35,R30
;     388 MCUCSR=0x00;
	OUT  0x34,R30
;     389 
;     390 // Timer(s)/Counter(s) Interrupt(s) initialization
;     391 TIMSK=0x01;
	LDI  R30,LOW(1)
	OUT  0x39,R30
;     392 
;     393 // Analog Comparator initialization
;     394 // Analog Comparator: Off
;     395 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     396 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     397 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     398 
;     399 // LCD module initialization
;     400 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _lcd_init
;     401 
;     402 // Global enable interrupts
;     403 //#asm("sei")
;     404 
;     405 while (1)
_0x44:
;     406       {
;     407       // Place your code here
;     408           clock();
	CALL _clock
;     409           show_info();
	CALL _show_info
;     410       };
	RJMP _0x44
;     411 }
_0x47:
	RJMP _0x47

_abs:
    ld   r30,y+
    ld   r31,y+
    sbiw r30,0
    brpl __abs0
    com  r30
    com  r31
    adiw r30,1
__abs0:
    ret
_modf:
	__GETD1S 2
	CALL __CPD10
	BRNE _0x48
	LD   R26,Y
	LDD  R27,Y+1
	__GETD1N 0x0
	CALL __PUTDP1
	RJMP _0x5C
_0x48:
	__GETD2S 2
	CALL __CPD02
	BRGE _0x49
	__GETD1S 2
	CALL __PUTPARD1
	CALL _floor
	RJMP _0x5E
_0x49:
	__GETD1S 2
	CALL __PUTPARD1
	CALL _ceil
_0x5E:
	LD   R26,Y
	LDD  R27,Y+1
	CALL __PUTDP1
	LD   R26,Y
	LDD  R27,Y+1
	CALL __GETD1P
	__GETD2S 2
	CALL __SWAPD12
	CALL __SUBF12
_0x5C:
	ADIW R28,6
	RET
_sin:
	SBIW R28,4
	ST   -Y,R17
	LDI  R17,0
	__GETD2S 5
	__GETD1N 0x3E22F983
	CALL __MULF12
	__PUTD1S 5
	CALL __PUTPARD1
	CALL _floor
	__GETD2S 5
	CALL __SWAPD12
	CALL __SUBF12
	__PUTD1S 5
	__GETD2S 5
	__GETD1N 0x3F000000
	CALL __CMPF12
	BREQ PC+2
	BRCC PC+3
	JMP  _0x4B
	CALL __SWAPD12
	CALL __SUBF12
	__PUTD1S 5
	LDI  R17,LOW(1)
_0x4B:
	__GETD2S 5
	__GETD1N 0x3E800000
	CALL __CMPF12
	BREQ PC+2
	BRCC PC+3
	JMP  _0x4C
	__GETD1N 0x3F000000
	CALL __SUBF12
	__PUTD1S 5
_0x4C:
	CPI  R17,0
	BREQ _0x4D
	__GETD1S 5
	CALL __ANEGF1
	__PUTD1S 5
_0x4D:
	__GETD1S 5
	__GETD2S 5
	CALL __MULF12
	__PUTD1S 1
	__GETD2N 0x4226C4B1
	CALL __MULF12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x422DE51D
	CALL __SWAPD12
	CALL __SUBF12
	__GETD2S 1
	CALL __MULF12
	__GETD2N 0x4104534C
	CALL __ADDF12
	__GETD2S 5
	CALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETD1S 1
	__GETD2N 0x3FDEED11
	CALL __ADDF12
	__GETD2S 1
	CALL __MULF12
	__GETD2N 0x3FA87B5E
	CALL __ADDF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __DIVF21
	LDD  R17,Y+0
	ADIW R28,9
	RET
_cos:
	__GETD2S 0
	__GETD1N 0x3FC90FDB
	CALL __SUBF12
	CALL __PUTPARD1
	CALL _sin
	RJMP _0x5B
_xatan:
	SBIW R28,4
	__GETD1S 4
	__GETD2S 4
	CALL __MULF12
	__PUTD1S 0
	__GETD2N 0x40CBD065
	CALL __MULF12
	__GETD2N 0x414A8F4E
	CALL __ADDF12
	__GETD2S 4
	CALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETD1S 0
	__GETD2N 0x41296D00
	CALL __ADDF12
	__GETD2S 0
	CALL __MULF12
	__GETD2N 0x414A8F4E
	CALL __ADDF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __DIVF21
	ADIW R28,8
	RET
_yatan:
	__GETD2S 0
	__GETD1N 0x3ED413CD
	CALL __CMPF12
	BRSH _0x4E
	__GETD1S 0
	CALL __PUTPARD1
	CALL _xatan
	RJMP _0x5B
_0x4E:
	__GETD2S 0
	__GETD1N 0x401A827A
	CALL __CMPF12
	BREQ PC+2
	BRCC PC+3
	JMP  _0x4F
	__GETD1S 0
	__GETD2N 0x3F800000
	CALL __DIVF21
	CALL __PUTPARD1
	CALL _xatan
	__GETD2N 0x3FC90FDB
	CALL __SWAPD12
	CALL __SUBF12
	RJMP _0x5B
_0x4F:
	__GETD2S 0
	__GETD1N 0x3F800000
	CALL __SWAPD12
	CALL __SUBF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETD1S 0
	__GETD2N 0x3F800000
	CALL __ADDF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __DIVF21
	CALL __PUTPARD1
	CALL _xatan
	__GETD2N 0x3F490FDB
	CALL __ADDF12
	RJMP _0x5B
_atan:
	__GETD2S 0
	CALL __CPD20
	BRLT _0x50
	__GETD1S 0
	CALL __PUTPARD1
	CALL _yatan
	RJMP _0x5B
_0x50:
	__GETD1S 0
	CALL __ANEGF1
	CALL __PUTPARD1
	CALL _yatan
	CALL __ANEGF1
_0x5B:
	ADIW R28,4
	RET
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG
__base_y_G3:
	.BYTE 0x4

	.CSEG
__lcd_delay_G3:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
	RET
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
	CALL __lcd_delay_G3
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G3
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G3
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G3
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble_G3:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G3
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G3
	RET
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf0 | (1<<__lcd_rs) | (1<<__lcd_rd) | (1<<__lcd_enable) ;set as output    
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	CALL __lcd_write_nibble_G3
    ld    r26,y
    swap  r26
	CALL __lcd_write_nibble_G3
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
__lcd_read_nibble_G3:
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G3
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G3
    andi  r30,0xf0
	RET
_lcd_read_byte0_G3:
	CALL __lcd_delay_G3
	CALL __lcd_read_nibble_G3
    mov   r26,r30
	CALL __lcd_read_nibble_G3
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	CALL __lcd_ready
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G3)
	SBCI R31,HIGH(-__base_y_G3)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	ST   -Y,R30
	CALL __lcd_write_data
	LDD  R3,Y+1
	LDD  R6,Y+0
	ADIW R28,2
	RET
_lcd_clear:
	CALL __lcd_ready
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL __lcd_ready
	LDI  R30,LOW(12)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL __lcd_ready
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL __lcd_write_data
	LDI  R30,LOW(0)
	MOV  R6,R30
	MOV  R3,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	INC  R3
	CP   R5,R3
	BRSH _0x52
	__lcd_putchar1:
	INC  R6
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R6
	CALL _lcd_gotoxy
	brts __lcd_putchar0
_0x52:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET
_lcd_putsf:
	ST   -Y,R17
_0x56:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x58
	ST   -Y,R17
	CALL _lcd_putchar
	RJMP _0x56
_0x58:
	LDD  R17,Y+0
	ADIW R28,3
	RET
__long_delay_G3:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G3:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	CALL __lcd_write_nibble_G3
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LDD  R5,Y+0
	LD   R30,Y
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G3,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G3,3
	CALL __long_delay_G3
	LDI  R30,LOW(48)
	ST   -Y,R30
	CALL __lcd_init_write_G3
	CALL __long_delay_G3
	LDI  R30,LOW(48)
	ST   -Y,R30
	CALL __lcd_init_write_G3
	CALL __long_delay_G3
	LDI  R30,LOW(48)
	ST   -Y,R30
	CALL __lcd_init_write_G3
	CALL __long_delay_G3
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL __lcd_init_write_G3
	CALL __long_delay_G3
	LDI  R30,LOW(40)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL __long_delay_G3
	LDI  R30,LOW(4)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL __long_delay_G3
	LDI  R30,LOW(133)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL __long_delay_G3
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	CALL _lcd_read_byte0_G3
	CPI  R30,LOW(0x5)
	BREQ _0x59
	LDI  R30,LOW(0)
	RJMP _0x5A
_0x59:
	CALL __lcd_ready
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL _lcd_clear
	LDI  R30,LOW(1)
_0x5A:
	ADIW R28,1
	RET

_sqrt:
	sbiw r28,4
	push r21
	ldd  r25,y+7
	tst  r25
	brne __sqrt0
	adiw r28,8
	rjmp __zerores
__sqrt0:
	brpl __sqrt1
	adiw r28,8
	rjmp __maxres
__sqrt1:
	push r20
	ldi  r20,66
	ldd  r24,y+6
	ldd  r27,y+5
	ldd  r26,y+4
__sqrt2:
	st   y,r24
	std  y+1,r25
	std  y+2,r26
	std  y+3,r27
	movw r30,r26
	movw r22,r24
	ldd  r26,y+4
	ldd  r27,y+5
	ldd  r24,y+6
	ldd  r25,y+7
	rcall __divf21
	ld   r24,y
	ldd  r25,y+1
	ldd  r26,y+2
	ldd  r27,y+3
	rcall __addf12
	rcall __unpack1
	dec  r23
	rcall __repack
	ld   r24,y
	ldd  r25,y+1
	ldd  r26,y+2
	ldd  r27,y+3
	eor  r26,r30
	andi r26,0xf8
	brne __sqrt4
	cp   r27,r31
	cpc  r24,r22
	cpc  r25,r23
	breq __sqrt3
__sqrt4:
	dec  r20
	breq __sqrt3
	movw r26,r30
	movw r24,r22
	rjmp __sqrt2
__sqrt3:
	pop  r20
	pop  r21
	adiw r28,8
	ret

__ftrunc:
	ldd  r23,y+3
	ldd  r22,y+2
	ldd  r31,y+1
	ld   r30,y
	bst  r23,7
	lsl  r23
	sbrc r22,7
	sbr  r23,1
	mov  r25,r23
	subi r25,0x7e
	breq __ftrunc0
	brcs __ftrunc0
	cpi  r25,24
	brsh __ftrunc1
	clr  r26
	clr  r27
	clr  r24
__ftrunc2:
	sec
	ror  r24
	ror  r27
	ror  r26
	dec  r25
	brne __ftrunc2
	and  r30,r26
	and  r31,r27
	and  r22,r24
	rjmp __ftrunc1
__ftrunc0:
	clt
	clr  r23
	clr  r30
	clr  r31
	clr  r22
__ftrunc1:
	cbr  r22,0x80
	lsr  r23
	brcc __ftrunc3
	sbr  r22,0x80
__ftrunc3:
	bld  r23,7
	ld   r26,y+
	ld   r27,y+
	ld   r24,y+
	ld   r25,y+
	cp   r30,r26
	cpc  r31,r27
	cpc  r22,r24
	cpc  r23,r25
	bst  r25,7
	ret

_floor:
	rcall __ftrunc
	brne __floor1
__floor0:
	ret
__floor1:
	brtc __floor0
	ldi  r25,0xbf

	rjmp __addfc

_ceil:
	rcall __ftrunc
	brne __ceil1
__ceil0:
	ret
__ceil1:
	brts __ceil0
	ldi  r25,0x3f

__addfc:
	clr  r26
	clr  r27
	ldi  r24,0x80
	rjmp __addf12

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__CWD2:
	MOV  R24,R27
	ADD  R24,R24
	SBC  R24,R24
	MOV  R25,R24
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__MULD12:
	RCALL __CHKSIGND
	RCALL __MULD12U
	BRTC __MULD121
	RCALL __ANEGD1
__MULD121:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__DIVD21:
	RCALL __CHKSIGND
	RCALL __DIVD21U
	BRTC __DIVD211
	RCALL __ANEGD1
__DIVD211:
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

__MODD21:
	CLT
	SBRS R25,7
	RJMP __MODD211
	COM  R26
	COM  R27
	COM  R24
	COM  R25
	SUBI R26,-1
	SBCI R27,-1
	SBCI R24,-1
	SBCI R25,-1
	SET
__MODD211:
	SBRC R23,7
	RCALL __ANEGD1
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	BRTC __MODD212
	RCALL __ANEGD1
__MODD212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__CHKSIGND:
	CLT
	SBRS R23,7
	RJMP __CHKSD1
	RCALL __ANEGD1
	SET
__CHKSD1:
	SBRS R25,7
	RJMP __CHKSD2
	CLR  R0
	COM  R26
	COM  R27
	COM  R24
	COM  R25
	ADIW R26,1
	ADC  R24,R0
	ADC  R25,R0
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSD2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__PUTDP1:
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__GETD1PF:
	LPM  R0,Z+
	LPM  R1,Z+
	LPM  R22,Z+
	LPM  R23,Z
	MOVW R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__CDF2U:
	SET
	RJMP __CDF2U0
__CDF2:
	CLT
__CDF2U0:
	RCALL __SWAPD12
	RCALL __CDF1U0

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__ANEGF1:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __ANEGF10
	SUBI R23,0x80
__ANEGF10:
	RET

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF129
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__CPW02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	RET

__CPD20:
	SBIW R26,0
	SBCI R24,0
	SBCI R25,0
	RET

__CPD02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	CPC  R0,R24
	CPC  R0,R25
	RET

__CPD12:
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	CPC  R23,R25
	RET

;END OF CODE MARKER
__END_OF_CODE:
